### Function

# FwupdPlugin memread_string_safe

since: 2.1.4

#### Declaration [src]

    GString*
    fu_memread_string_safe (
      const guint8* buf,
      gsize bufsz,
      gsize offset,
      GError** error
    )

#### Description [src]

Reads a NUL-terminated string from a buffer.

Available since: 2.1.4

#### Parameters

`buf`

  Type: `const guint8*`

  Source buffer.

  The data is owned by the caller of the function.

`bufsz`

  Type: `gsize`

  Maximum size of `buf`, typically `sizeof(buf)`.

`offset`

  Type: `gsize`

  Offset in bytes into `buf` to read from.

`error`

  Type: `GError **`

  The return location for a recoverable error.

  The argument can be `NULL`.
  If the return location is not `NULL`, then you must initialize it to a `NULL` `GError*`.
  The argument will be left initialized to `NULL` by the function if there are no errors.
  In case of error, the argument will be set to a newly allocated `GError`; the caller will take ownership of the data, and be responsible for freeing it.

#### Return value

Type: `GString`

A string, or `NULL` on error.

The caller of the function takes ownership of the data, and is responsible for freeing it.